﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;

namespace RouteTesting.Tests.Routes
{
	[TestFixture]
	public class UrlGenerationFixture : RouteFixtureBase
	{
		/* ====== TestBlogPath test ====== */

		/// <summary>
		///  Tests that we get the correct URL for a blog entry.
		/// </summary>

		[Test]
		public void TestBlogPath()
		{
			AssertRouteUrl(
				/*
				 * currentPage is an app-relative URL, so it must be
				 * prefixed with a tilde (~). Note that this is required
				 * and must point to a valid route.
				 */
				"~/blog/2008/10/25",
				/*
				 * expectedUrl, on the other hand, is an absolute path,
				 * so it shouldn't.
				 */
				"/blog/2008/10/10",
				/*
				 * The route data. Note that you specify your controller and
				 * action here as the controller and action properties 
				 * respectively.
				 */
				new {
					controller = "blog",
					action = "index",
					year = "2008",
					month = "10",
					day = "10"
				}
			);
		}

		/* ====== TestGeneralPath ====== */

		[Test]
		public void TestGeneralPath()
		{
			AssertRouteUrl(
				"~/blog/2008/10/25",
				"/foo/bar/baz",
				new {
					controller = "foo",
					action = "bar",
					id = "baz"
				}
			);
		}

	}
}
